; Script for "ApexDC".
; Version script 035.
; Copyright - Ivan Denishev, sitedia@narod.ru

Include "HjGlobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; JAWS default constants
Include "Common.jsm" Include "MSAAConst.jsh"
Use "Smiles.jsb"

Globals
String DC_AllMessage,
String DC_ListMessage,
Int DC_TimeMessage,

String DC_ListHubUser,
String DC_ListAllUser,
Int DC_ActiveHubSound,
Int DC_NotSpeak,
Int DC_SearchList,
Int DC_UpDownBool,
String DC_ListUpDown,
Int DC_NumListUD,
String DC_Dubuffer,
Handle DC_RestoreWindow

Function AutoStartEvent ()
Let DC_AllMessage = ""
Let DC_SearchList = 0
Refresh ()
AutoStartEvent ()
EndFunction

function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
If (IsPCCursor ()) Then
If (GetControlID (FocusWindow) == 10059) Then
If Not StringIsBlank (DC_ListMessage) Then
Say ("  : ", OT_SCREEN_MESSAGE)
SaySelectMessage(1)
EndIf
Return
EndIf
If (GetControlID (FocusWindow) == 1006) Then
Let DC_NotSpeak = 1
SayLine()
Return
EndIf
If (GetControlID (FocusWindow) == 10059) Then
Let DC_NotSpeak = 2
Return
EndIf
EndIf
Let DC_NotSpeak = 0

FocusChangedEvent (FocusWindow, PrevWindow)
EndFunction

void Function SaveMessages (String DC_BufMess)
Var
String TempMessage
If (StringLength(DC_BufMess) < 3) Then
Return
EndIf
Let DC_ListMessage = DC_BufMess + LIST_ITEM_SEPARATOR + DC_ListMessage
If (StringSegmentCount(DC_ListMessage, LIST_ITEM_SEPARATOR) == 12) Then
Let TempMessage = StringSegment(DC_ListMessage, LIST_ITEM_SEPARATOR, 12)
Let DC_ListMessage = StringLeft(DC_ListMessage, (StringLength(DC_ListMessage) - StringLength(TempMessage) - 1))
EndIf
EndFunction

Void Function SaySelectMessage (int ssmParam)
Var
String NotTimeMessage

If (StringSegmentCount(DC_ListMessage, LIST_ITEM_SEPARATOR) > (ssmParam + 1)) Then
If (DC_TimeMessage) Then
Say (StringSegment(DC_ListMessage, LIST_ITEM_SEPARATOR, ssmParam), OT_SCREEN_MESSAGE)
Else
Let NotTimeMessage = StringSegment(DC_ListMessage, LIST_ITEM_SEPARATOR, ssmParam)
;Say (StringSegment(NotTimeMessage, "]", 2), OT_SCREEN_MESSAGE)
Say (StringRight(NotTimeMessage, (StringLength(NotTimeMessage) - 10)), OT_SCREEN_MESSAGE)
EndIf
Else
Say (" " + IntToString(ssmParam) + " .", OT_SCREEN_MESSAGE)
EndIf
EndFunction

Void Function SayNonHighlightedText (handle hwnd, string buffer)
Var Int DC_ControlID
Let DC_ControlID = GetControlID (hwnd)
; .
If (DC_ControlID == 10059) Then
If (StringLeft(buffer, 1) == "[") Then
SaveMessages(DC_AllMessage)
Let DC_AllMessage = buffer
Else
Let DC_AllMessage = DC_AllMessage + buffer
;SayString (StringLeft(buffer, 1))
;If (StringLeft(buffer, 1) == ">") || (StringLeft(buffer, 1) == "*") Then
;SaveMessages(DC_AllMessage)
;EndIf
EndIf
Return
EndIf

;  .
If (DC_ControlID == 1006) Then
;Let DC_ListHubUser = DC_ListHubUser + StringSegment(buffer, " ", 1) + LIST_ITEM_SEPARATOR
Let DC_ListHubUser = buffer
Return
EndIf

;  .
If ((DC_ControlID == 1019) && (DC_SearchList == 0)) Then
;        .
If ((GetControlID (GetFocus ()) != 1001) && (GetControlId (GetFocus ()) != 1019)) Then
SetFocus (FindWindowWithClassAndID (GetRealWindow (GetFocus ()), "", 1019))
Say (" :", OT_SCREEN_MESSAGE)
EndIf
Return
EndIf

;  .
If (DC_ControlID == 1017) Then
;   .
If (DC_UpDownBool) Then
Var
String DC_SegmentList1,
String DC_SegmentList2,
String DC_YesBuffer
If ((StringSegmentCount(buffer, "") == 2) || (StringSegmentCount(buffer, "") == 2) || ( StringSegmentCount(buffer, "") == 2)) Then
Let DC_YesBuffer = buffer
Else
Let DC_Dubuffer = DC_Dubuffer + " " + buffer
Return
EndIf
Let DC_NumListUD = DC_NumListUD + 1
Let DC_SegmentList1 = StringSegment(DC_ListUpDown, LIST_ITEM_SEPARATOR, DC_NumListUD)
Let DC_SegmentList2 = StringSegment(DC_Dubuffer, " ", 2)
;SayString(StringSegment(DC_SegmentList1, " ", 2)+" "+DC_SegmentList2)
If (StringSegment(DC_SegmentList1, " ", 2) != DC_SegmentList2) Then
Let DC_ListUpDown = StringSegment(DC_ListUpDown, DC_SegmentList1, 1) + DC_Dubuffer + StringSegment(DC_ListUpDown, DC_SegmentList1, 2)
Say (DC_SegmentList1, OT_SCREEN_MESSAGE)
EndIf
If (DC_YesBuffer != "") Then
Let DC_ListUpDown = DC_Dubuffer + LIST_ITEM_SEPARATOR + DC_ListUpDown
Let DC_Dubuffer = DC_YesBuffer
Let DC_YesBuffer = ""
EndIf
EndIf
Return
EndIF

;  .
If (DC_ControlID == 59393) Then
Var String DC_TextStat
;    .
If (GetControlID(GetFocus()) == 1037 && StringLeft(buffer, 2) == "") Then
Say (buffer, OT_SCREEN_MESSAGE)
Return
EndIf
;   .
If (GetControlID(GetFocus()) == 0 && StringLeft(buffer, 2) == "") Then
Say (buffer, OT_SCREEN_MESSAGE)
Return
EndIf
;   .
If (GetControlID(GetFocus()) == 1078 && StringLeft(buffer, 2) == "") Then
Say (buffer, OT_SCREEN_MESSAGE)
Return
EndIf
;   .
If (GetControlID(GetFocus()) == 1019 && StringRight(buffer, 2) == "") Then
Say (buffer, OT_SCREEN_MESSAGE)
Return
EndIf
;   .
If (GetControlID(GetFocus()) == 135) Then
Let DC_TextStat = StringLeft(buffer, 2)
If (DC_TextStat == "" || DC_TextStat == "" || DC_TextStat == "" || StringRight(buffer, 2) == "") Then
Say (buffer, OT_SCREEN_MESSAGE)
Return
EndIf
EndIf
EndIf
SayNonHighlightedText (hwnd, buffer)
EndFunction

void function ScreenStabilizedEvent(handle hwndLastScreenWrite)
Var
Int DC_ListShiftUser,
Int DC_FocusControl
If (DC_NotSpeak > 0) then
Return
EndIf
Let DC_FocusControl = GetControlID(GetFocus ())

; .
If (Not StringIsBlank (DC_AllMessage)) Then
SaveMessages(DC_AllMessage)
If (GetWindowClass(GetFocus()) != "Edit" && DC_FocusControl != 10059) Then
StopSpeech ()
EndIf
If (DC_FocusControl != 10059 && DC_FocusControl != 1006) Then
PlaySound(GetJAWSSettingsDirectory() + "/Sounds/dc_new_message.wav")
SaySelectMessage(1)
EndIf
Let DC_AllMessage = cScNull
;SayString(GetWindowText(hwndLastScreenWrite, False))
Return
EndIf

;  .
If Not StringIsBlank (DC_ListHubUser) Then
If (DC_ActiveHubSound) Then
PlaySound(GetJAWSSettingsDirectory() + "/Sounds/dc_users.wav")
EndIf
Let DC_ListHubUser = cScNull
Return
EndIf

;   .
If (DC_UpDownBool) Then
Let DC_NumListUD = 0
EndIf

ScreenStabilizedEvent(hwndLastScreenWrite)
EndFunction


Script StartStopHubSound ()
Let DC_ActiveHubSound = Not DC_ActiveHubSound
If (DC_ActiveHubSound) Then
Say (" .", OT_SCREEN_MESSAGE)
Else
Say (" .", OT_SCREEN_MESSAGE)
EndIf
EndScript

Script SayAlt1 ()
SaySelectMessage (1)
EndScript

Script SayAlt2 ()
SaySelectMessage (2)
EndScript

Script SayAlt3 ()
SaySelectMessage (3)
EndScript

Script SayAlt4 ()
SaySelectMessage (4)
EndScript

Script SayAlt5 ()
SaySelectMessage (5)
EndScript

Script SayAlt6 ()
SaySelectMessage (6)
EndScript

Script SayAlt7 ()
SaySelectMessage (7)
EndScript

Script SayAlt8 ()
SaySelectMessage (8)
EndScript

Script SayAlt9 ()
SaySelectMessage (9)
EndScript

Script SayAlt10 ()
Let DC_TimeMessage = Not DC_TimeMessage
If (DC_TimeMessage) Then
Say (" .", OT_SCREEN_MESSAGE)
Else
Say (" .", OT_SCREEN_MESSAGE)
EndIf
EndScript

Script CTRLTabPress ()
{CTRL+Tab}
Let DC_SearchList = 0
Refresh()
EndScript

Script CTRLShiftTabPress ()
{CTRL+Shift+Tab}
Let DC_SearchList = 0
Refresh()
EndScript

Script PassOutWindow ()
; PC  ?
If (IsPCCursor ()) Then
;     .
If (GetControlID (GetFocus ()) != 1017) Then
;   .
Let DC_RestoreWindow = GetFocus ()
;    .
Say (":", OT_SCREEN_MESSAGE)
Var Object DC_outList,
Int DC_Child, Int DC_Temp
let DC_outList = GetObjectFromEvent (FindWindowWithClassAndID (GetAppMainWindow (GetFocus ()), "", 1017), OBJID_CLIENT, DC_Child, DC_Temp)
DC_outList.accSelect (SELFLAG_TAKEFOCUS | SELFLAG_TAKESELECTION, 1)
Else
Say ("     !", OT_SCREEN_MESSAGE)
EndIf
Else
SayString("No PC Cursor")
EndIf
EndScript

Script RestorePassWindow ()
; PC  ?
If (IsPCCursor ()) Then
;     ?
If (GetControlID (GetFocus ()) == 1017) Then
;    .
SetFocus (DC_RestoreWindow)
;     .
If (GetWindowClass (DC_RestoreWindow) == "Edit") Then
JAWSEnd ()
Else
;;     .
{Space}
EndIf
;SayInteger(DC_RestoreWindow)
;Var Object DC_outList,
;Int DC_Child, Int DC_Temp
;Let DC_outList = GetObjectFromEvent (DC_RestoreWindow, OBJID_CLIENT, DC_Child, DC_Temp)
;DC_outList.accSelect (SELFLAG_TAKEFOCUS | SELFLAG_TAKESELECTION, 1)
Else
Say ("   ", OT_SCREEN_MESSAGE)
EndIf
Else
SayString("No PC Cursor")
EndIf
EndScript

Script UpDownSpeak ()
; PC  ?
If (IsPCCursor ()) Then
Let DC_UpDownBool = Not DC_UpDownBool
Let DC_ListUpDown = ""
If DC_UpDownBool Then
Say (" ", OT_SCREEN_MESSAGE)
Else
Say (" ", OT_SCREEN_MESSAGE)
EndIf
Else
SayString("No PC Cursor")
EndIf
EndScript

Script RightClickToPC ()
If (IsPCCursor()) then
JAWSCursor()
SaveCursor()
RouteJAWSToPC()
RightMouseButton()
RestoreCursor()
PCCursor()
Else
Say ("No PC Cursor", OT_SCREEN_MESSAGE)
EndIf
EndScript

Script LeftClickFromPC ()
If (IsPCCursor()) then
JAWSCursor()
SaveCursor()
RouteJAWSToPC()
LeftMouseButton()
RestoreCursor()
PCCursor()
Else
SayString("No PC Cursor")
EndIf
EndScript

Script DBLLeftClickFromPC ()
If (IsPCCursor()) then
JAWSCursor()
SaveCursor()
RouteJAWSToPC()
LeftMouseButton() LeftMouseButton()
RestoreCursor()
PCCursor()
Else
SayString("No PC Cursor")
EndIf
EndScript


Script SearchTab ()
Var
Int DC_RealControlID,
String DC_ParentName

; PC  ?
If (IsPCCursor ()) Then
;   .
Let DC_RealControlID = GetControlID (GetFocus ())
;    .
Let DC_ParentName = GetWindowName (GetParent (GetCurrentWindow ()))
;SayString ("window: "+DC_ParentName)

;  "".
If ((DC_ParentName == "Search") || (DC_ParentName == "")) Then
;    .
If (DC_RealControlID == 125) Then
;     .
SetFocus (FindWindowWithClassAndID (GetRealWindow (GetFocus ()), "", 1103))
Say (":", OT_SCREEN_MESSAGE)

;    .
ElIf (DC_RealControlID == 1103) Then
;     .
SetFocus (FindWindowWithClassAndID (GetRealWindow (GetFocus ()), "", 1078))

;    .
ElIf (DC_RealControlID == 1078) Then
;   .
SetFocus (FindWindowWithClassAndID (GetRealWindow (GetFocus ()), "", 1019))
Say (" :", OT_SCREEN_MESSAGE)

;    .
ElIf (DC_RealControlID == 1019) Then
;    .
SetFocus (FindWindowWithClassAndID (GetRealWindow (GetFocus ()), "", 1001))
Say (DC_ParentName, OT_SCREEN_MESSAGE)
;    , .
If (GetControlName () != "") Then
SayLine ()
EndIf
Else
TabKey()
EndIf

;   :
ElIf ((DC_ParentName == "") || (DC_ParentName == "Options")) Then
;   .
If (DC_RealControlID == 2) Then
;   .
SetFocus (FindWindowWithClassAndID (GetRealWindow (GetFocus ()), "", 1130))
Else
TabKey()
EndIf

Else
TabKey()
EndIf
Else
SayString("No PC Cursor")
EndIf
EndScript

Script CopyNameList ()
; PC  ?
If (IsPCCursor ()) Then
; ,     .
If (GetControlID (GetFocus ()) == 1037) Then
StopSpeech () SpeechOff ()
CopyToClipboard (StringSegment(GetControlName(), ",", 1))
PerformScript RightClickToPC()
Pause () EnterKey() Pause ()
PerformScript PasteFromClipboard()
SpeechOn () JAWSHome () SayWord ()
Else
Say ("   .", OT_SCREEN_MESSAGE)
EndIf
Else
SayString("No PC Cursor")
EndIf
EndScript
